security:
  encoders:
    App\Entity\User:
      algorithm: argon2i

  # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
  providers:
    # used to reload user from session & other features (e.g. switch_user)
    app_user_provider:
      entity:
        class: App\Entity\User
        property: email

  firewalls:
    dev:
      pattern: ^/_(profiler|wdt)
      security: false
    main:
      stateless: true
      anonymous: true
      provider: app_user_provider
      json_login:
        check_path: /login
        username_path: email
        password_path: password
        success_handler: lexik_jwt_authentication.handler.authentication_success
        failure_handler: lexik_jwt_authentication.handler.authentication_failure
      guard:
        authenticators:
          - lexik_jwt_authentication.jwt_token_authenticator

  role_hierarchy:
    ROLE_INVESTOR: ROLE_USER
    ROLE_ENTREPRENEUR: ROLE_USER
    ROLE_ADMIN: [ROLE_USER, ROLE_INVESTOR, ROLE_ENTREPRENEUR]

  access_control:
    - { path: ^/docs, roles: IS_AUTHENTICATED_ANONYMOUSLY } # Allows accessing the Swagger UI
    - { path: ^/login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
    - { path: ^/users, roles: IS_AUTHENTICATED_ANONYMOUSLY, methods: [POST]}
    - { path: ^/, roles: IS_AUTHENTICATED_FULLY }
